Subject: Re: [PATCH] net: tsn: add an netlink interface between kernel and application layer

From: Ilias Apalodimas <[email-masked]>
Date: Thu, 3 Jan 2019 11:16:05 +0200

Hi Po,

> > Hi Vinicius,
> >
> > Thank you very much for your feedback.
> >
> > I know the CBS is used to be most important part of AVB. And qdiscs is good tool to configure qos. 
> >
> > But as you know, the TSN family is a cluster of protocols and much extending the AVB. The protocols have different  functionalities and they may have more than hundred  parameters. For example NXP ls1028a support Qbv/Qci/Qbu/Qav and also the 8021CB (not included in this patch yet).
> >
> > Some protocols target to configure the traffic class(like Qav CBS).
> > Some to config the port(like Qbv). But some for the whole ethernet
> > controller(like Qci, the control entries for the whole controller,
> > which input ports and which output ports).
> 
> Reading your email, now I understand your point a little better. You are
> interested in multi-port devices. I admit that I am not too familiar
> with how multi-port devices are exposed in Linux, I was only focused on
> the end-station use cases, until now.

Have you considered a switchdev-based driver for multi-port devices?
What you ask of TSN configuration is currently doable with switch switchdev for
VLANs and other similar networking functionality. 

Instead of rewriting this from scratch, we not extend the currect TC and
switchdev functionality for that ?

Regards
/Ilias